import { toRefs as Tt, ref as Ut, computed as gt, onMounted as gr, onUnmounted as br, watch as pt, openBlock as qt, createElementBlock as Zt, mergeProps as Ne, defineComponent as xr, normalizeClass as Se, createVNode as yr, unref as At, isRef as wr, normalizeStyle as Sr, createCommentVNode as ke, createBlock as kr, normalizeProps as Er } from "vue";
import { isArray as Pr } from "lodash-es";
import { a6 as Cr, a7 as Nr, a9 as Vr, ai as Ee, u as zr } from "./index-42422916.js";
import "axios";
import "@vueuse/core";
import "vue-i18n";
function Ht(V) {
  return [null, void 0, !1].indexOf(V) !== -1;
}
function Ar(V) {
  return V && V.__esModule && Object.prototype.hasOwnProperty.call(V, "default") ? V.default : V;
}
function Ve(V) {
  var A = { exports: {} };
  return V(A, A.exports), A.exports;
}
var Pe = Ve(function(V, A) {
  V.exports = function() {
    var f = ["decimals", "thousand", "mark", "prefix", "suffix", "encoder", "decoder", "negativeBefore", "negative", "edit", "undo"];
    function st(d) {
      return d.split("").reverse().join("");
    }
    function O(d, h) {
      return d.substring(0, h.length) === h;
    }
    function ft(d, h) {
      return d.slice(-1 * h.length) === h;
    }
    function tt(d, h, m) {
      if ((d[h] || d[m]) && d[h] === d[m])
        throw new Error(h);
    }
    function S(d) {
      return typeof d == "number" && isFinite(d);
    }
    function M(d, h) {
      return d = d.toString().split("e"), (+((d = (d = Math.round(+(d[0] + "e" + (d[1] ? +d[1] + h : h)))).toString().split("e"))[0] + "e" + (d[1] ? +d[1] - h : -h))).toFixed(h);
    }
    function H(d, h, m, E, k, mt, ht, D, ot, W, q, x) {
      var ct, F, at, ut = x, et = "", w = "";
      return mt && (x = mt(x)), !!S(x) && (d !== !1 && parseFloat(x.toFixed(d)) === 0 && (x = 0), x < 0 && (ct = !0, x = Math.abs(x)), d !== !1 && (x = M(x, d)), (x = x.toString()).indexOf(".") !== -1 ? (at = (F = x.split("."))[0], m && (et = m + F[1])) : at = x, h && (at = st(at).match(/.{1,3}/g), at = st(at.join(st(h)))), ct && D && (w += D), E && (w += E), ct && ot && (w += ot), w += at, w += et, k && (w += k), W && (w = W(w, ut)), w);
    }
    function $(d, h, m, E, k, mt, ht, D, ot, W, q, x) {
      var ct, F = "";
      return q && (x = q(x)), !(!x || typeof x != "string") && (D && O(x, D) && (x = x.replace(D, ""), ct = !0), E && O(x, E) && (x = x.replace(E, "")), ot && O(x, ot) && (x = x.replace(ot, ""), ct = !0), k && ft(x, k) && (x = x.slice(0, -1 * k.length)), h && (x = x.split(h).join("")), m && (x = x.replace(m, ".")), ct && (F += "-"), (F = (F += x).replace(/[^0-9\.\-.]/g, "")) !== "" && (F = Number(F), ht && (F = ht(F)), !!S(F) && F));
    }
    function C(d) {
      var h, m, E, k = {};
      for (d.suffix === void 0 && (d.suffix = d.postfix), h = 0; h < f.length; h += 1)
        if ((E = d[m = f[h]]) === void 0)
          m !== "negative" || k.negativeBefore ? m === "mark" && k.thousand !== "." ? k[m] = "." : k[m] = !1 : k[m] = "-";
        else if (m === "decimals") {
          if (!(E >= 0 && E < 8))
            throw new Error(m);
          k[m] = E;
        } else if (m === "encoder" || m === "decoder" || m === "edit" || m === "undo") {
          if (typeof E != "function")
            throw new Error(m);
          k[m] = E;
        } else {
          if (typeof E != "string")
            throw new Error(m);
          k[m] = E;
        }
      return tt(k, "mark", "thousand"), tt(k, "prefix", "negative"), tt(k, "prefix", "negativeBefore"), k;
    }
    function U(d, h, m) {
      var E, k = [];
      for (E = 0; E < f.length; E += 1)
        k.push(d[f[E]]);
      return k.push(m), h.apply("", k);
    }
    function j(d) {
      if (!(this instanceof j))
        return new j(d);
      typeof d == "object" && (d = C(d), this.to = function(h) {
        return U(d, H, h);
      }, this.from = function(h) {
        return U(d, $, h);
      });
    }
    return j;
  }();
}), Mr = Ar(Ve(function(V, A) {
  (function(f) {
    function st(r) {
      return O(r) && typeof r.from == "function";
    }
    function O(r) {
      return typeof r == "object" && typeof r.to == "function";
    }
    function ft(r) {
      r.parentElement.removeChild(r);
    }
    function tt(r) {
      return r != null;
    }
    function S(r) {
      r.preventDefault();
    }
    function M(r) {
      return r.filter(function(t) {
        return !this[t] && (this[t] = !0);
      }, {});
    }
    function H(r, t) {
      return Math.round(r / t) * t;
    }
    function $(r, t) {
      var n = r.getBoundingClientRect(), c = r.ownerDocument, l = c.documentElement, g = mt(c);
      return /webkit.*Chrome.*Mobile/i.test(navigator.userAgent) && (g.x = 0), t ? n.top + g.y - l.clientTop : n.left + g.x - l.clientLeft;
    }
    function C(r) {
      return typeof r == "number" && !isNaN(r) && isFinite(r);
    }
    function U(r, t, n) {
      n > 0 && (m(r, t), setTimeout(function() {
        E(r, t);
      }, n));
    }
    function j(r) {
      return Math.max(Math.min(r, 100), 0);
    }
    function d(r) {
      return Array.isArray(r) ? r : [r];
    }
    function h(r) {
      var t = (r = String(r)).split(".");
      return t.length > 1 ? t[1].length : 0;
    }
    function m(r, t) {
      r.classList && !/\s/.test(t) ? r.classList.add(t) : r.className += " " + t;
    }
    function E(r, t) {
      r.classList && !/\s/.test(t) ? r.classList.remove(t) : r.className = r.className.replace(new RegExp("(^|\\b)" + t.split(" ").join("|") + "(\\b|$)", "gi"), " ");
    }
    function k(r, t) {
      return r.classList ? r.classList.contains(t) : new RegExp("\\b" + t + "\\b").test(r.className);
    }
    function mt(r) {
      var t = window.pageXOffset !== void 0, n = (r.compatMode || "") === "CSS1Compat";
      return { x: t ? window.pageXOffset : n ? r.documentElement.scrollLeft : r.body.scrollLeft, y: t ? window.pageYOffset : n ? r.documentElement.scrollTop : r.body.scrollTop };
    }
    function ht() {
      return window.navigator.pointerEnabled ? { start: "pointerdown", move: "pointermove", end: "pointerup" } : window.navigator.msPointerEnabled ? { start: "MSPointerDown", move: "MSPointerMove", end: "MSPointerUp" } : { start: "mousedown touchstart", move: "mousemove touchmove", end: "mouseup touchend" };
    }
    function D() {
      var r = !1;
      try {
        var t = Object.defineProperty({}, "passive", { get: function() {
          r = !0;
        } });
        window.addEventListener("test", null, t);
      } catch {
      }
      return r;
    }
    function ot() {
      return window.CSS && CSS.supports && CSS.supports("touch-action", "none");
    }
    function W(r, t) {
      return 100 / (t - r);
    }
    function q(r, t, n) {
      return 100 * t / (r[n + 1] - r[n]);
    }
    function x(r, t) {
      return q(r, r[0] < 0 ? t + Math.abs(r[0]) : t - r[0], 0);
    }
    function ct(r, t) {
      return t * (r[1] - r[0]) / 100 + r[0];
    }
    function F(r, t) {
      for (var n = 1; r >= t[n]; )
        n += 1;
      return n;
    }
    function at(r, t, n) {
      if (n >= r.slice(-1)[0])
        return 100;
      var c = F(n, r), l = r[c - 1], g = r[c], N = t[c - 1], Y = t[c];
      return N + x([l, g], n) / W(N, Y);
    }
    function ut(r, t, n) {
      if (n >= 100)
        return r.slice(-1)[0];
      var c = F(n, t), l = r[c - 1], g = r[c], N = t[c - 1];
      return ct([l, g], (n - N) * W(N, t[c]));
    }
    function et(r, t, n, c) {
      if (c === 100)
        return c;
      var l = F(c, r), g = r[l - 1], N = r[l];
      return n ? c - g > (N - g) / 2 ? N : g : t[l - 1] ? r[l - 1] + H(c - r[l - 1], t[l - 1]) : c;
    }
    var w, J;
    f.PipsMode = void 0, (J = f.PipsMode || (f.PipsMode = {})).Range = "range", J.Steps = "steps", J.Positions = "positions", J.Count = "count", J.Values = "values", f.PipsType = void 0, (w = f.PipsType || (f.PipsType = {}))[w.None = -1] = "None", w[w.NoValue = 0] = "NoValue", w[w.LargeValue = 1] = "LargeValue", w[w.SmallValue = 2] = "SmallValue";
    var kt = function() {
      function r(t, n, c) {
        var l;
        this.xPct = [], this.xVal = [], this.xSteps = [], this.xNumSteps = [], this.xHighestCompleteStep = [], this.xSteps = [c || !1], this.xNumSteps = [!1], this.snap = n;
        var g = [];
        for (Object.keys(t).forEach(function(N) {
          g.push([d(t[N]), N]);
        }), g.sort(function(N, Y) {
          return N[0][0] - Y[0][0];
        }), l = 0; l < g.length; l++)
          this.handleEntryPoint(g[l][1], g[l][0]);
        for (this.xNumSteps = this.xSteps.slice(0), l = 0; l < this.xNumSteps.length; l++)
          this.handleStepPoint(l, this.xNumSteps[l]);
      }
      return r.prototype.getDistance = function(t) {
        for (var n = [], c = 0; c < this.xNumSteps.length - 1; c++)
          n[c] = q(this.xVal, t, c);
        return n;
      }, r.prototype.getAbsoluteDistance = function(t, n, c) {
        var l, g = 0;
        if (t < this.xPct[this.xPct.length - 1])
          for (; t > this.xPct[g + 1]; )
            g++;
        else
          t === this.xPct[this.xPct.length - 1] && (g = this.xPct.length - 2);
        c || t !== this.xPct[g + 1] || g++, n === null && (n = []);
        var N = 1, Y = n[g], R = 0, bt = 0, Q = 0, b = 0;
        for (l = c ? (t - this.xPct[g]) / (this.xPct[g + 1] - this.xPct[g]) : (this.xPct[g + 1] - t) / (this.xPct[g + 1] - this.xPct[g]); Y > 0; )
          R = this.xPct[g + 1 + b] - this.xPct[g + b], n[g + b] * N + 100 - 100 * l > 100 ? (bt = R * l, N = (Y - 100 * l) / n[g + b], l = 1) : (bt = n[g + b] * R / 100 * N, N = 0), c ? (Q -= bt, this.xPct.length + b >= 1 && b--) : (Q += bt, this.xPct.length - b >= 1 && b++), Y = n[g + b] * N;
        return t + Q;
      }, r.prototype.toStepping = function(t) {
        return t = at(this.xVal, this.xPct, t);
      }, r.prototype.fromStepping = function(t) {
        return ut(this.xVal, this.xPct, t);
      }, r.prototype.getStep = function(t) {
        return t = et(this.xPct, this.xSteps, this.snap, t);
      }, r.prototype.getDefaultStep = function(t, n, c) {
        var l = F(t, this.xPct);
        return (t === 100 || n && t === this.xPct[l - 1]) && (l = Math.max(l - 1, 1)), (this.xVal[l] - this.xVal[l - 1]) / c;
      }, r.prototype.getNearbySteps = function(t) {
        var n = F(t, this.xPct);
        return { stepBefore: { startValue: this.xVal[n - 2], step: this.xNumSteps[n - 2], highestStep: this.xHighestCompleteStep[n - 2] }, thisStep: { startValue: this.xVal[n - 1], step: this.xNumSteps[n - 1], highestStep: this.xHighestCompleteStep[n - 1] }, stepAfter: { startValue: this.xVal[n], step: this.xNumSteps[n], highestStep: this.xHighestCompleteStep[n] } };
      }, r.prototype.countStepDecimals = function() {
        var t = this.xNumSteps.map(h);
        return Math.max.apply(null, t);
      }, r.prototype.hasNoSize = function() {
        return this.xVal[0] === this.xVal[this.xVal.length - 1];
      }, r.prototype.convert = function(t) {
        return this.getStep(this.toStepping(t));
      }, r.prototype.handleEntryPoint = function(t, n) {
        var c;
        if (!C(c = t === "min" ? 0 : t === "max" ? 100 : parseFloat(t)) || !C(n[0]))
          throw new Error("noUiSlider: 'range' value isn't numeric.");
        this.xPct.push(c), this.xVal.push(n[0]);
        var l = Number(n[1]);
        c ? this.xSteps.push(!isNaN(l) && l) : isNaN(l) || (this.xSteps[0] = l), this.xHighestCompleteStep.push(0);
      }, r.prototype.handleStepPoint = function(t, n) {
        if (n)
          if (this.xVal[t] !== this.xVal[t + 1]) {
            this.xSteps[t] = q([this.xVal[t], this.xVal[t + 1]], n, 0) / W(this.xPct[t], this.xPct[t + 1]);
            var c = (this.xVal[t + 1] - this.xVal[t]) / this.xNumSteps[t], l = Math.ceil(Number(c.toFixed(3)) - 1), g = this.xVal[t] + this.xNumSteps[t] * l;
            this.xHighestCompleteStep[t] = g;
          } else
            this.xSteps[t] = this.xHighestCompleteStep[t] = this.xVal[t];
      }, r;
    }(), St = { to: function(r) {
      return r === void 0 ? "" : r.toFixed(2);
    }, from: Number }, rt = { target: "target", base: "base", origin: "origin", handle: "handle", handleLower: "handle-lower", handleUpper: "handle-upper", touchArea: "touch-area", horizontal: "horizontal", vertical: "vertical", background: "background", connect: "connect", connects: "connects", ltr: "ltr", rtl: "rtl", textDirectionLtr: "txt-dir-ltr", textDirectionRtl: "txt-dir-rtl", draggable: "draggable", drag: "state-drag", tap: "state-tap", active: "active", tooltip: "tooltip", pips: "pips", pipsHorizontal: "pips-horizontal", pipsVertical: "pips-vertical", marker: "marker", markerHorizontal: "marker-horizontal", markerVertical: "marker-vertical", markerNormal: "marker-normal", markerLarge: "marker-large", markerSub: "marker-sub", value: "value", valueHorizontal: "value-horizontal", valueVertical: "value-vertical", valueNormal: "value-normal", valueLarge: "value-large", valueSub: "value-sub" }, I = { tooltips: ".__tooltips", aria: ".__aria" };
    function dt(r, t) {
      if (!C(t))
        throw new Error("noUiSlider: 'step' is not numeric.");
      r.singleStep = t;
    }
    function vt(r, t) {
      if (!C(t))
        throw new Error("noUiSlider: 'keyboardPageMultiplier' is not numeric.");
      r.keyboardPageMultiplier = t;
    }
    function Et(r, t) {
      if (!C(t))
        throw new Error("noUiSlider: 'keyboardMultiplier' is not numeric.");
      r.keyboardMultiplier = t;
    }
    function Pt(r, t) {
      if (!C(t))
        throw new Error("noUiSlider: 'keyboardDefaultStep' is not numeric.");
      r.keyboardDefaultStep = t;
    }
    function it(r, t) {
      if (typeof t != "object" || Array.isArray(t))
        throw new Error("noUiSlider: 'range' is not an object.");
      if (t.min === void 0 || t.max === void 0)
        throw new Error("noUiSlider: Missing 'min' or 'max' in 'range'.");
      r.spectrum = new kt(t, r.snap || !1, r.singleStep);
    }
    function v(r, t) {
      if (t = d(t), !Array.isArray(t) || !t.length)
        throw new Error("noUiSlider: 'start' option is incorrect.");
      r.handles = t.length, r.start = t;
    }
    function T(r, t) {
      if (typeof t != "boolean")
        throw new Error("noUiSlider: 'snap' option must be a boolean.");
      r.snap = t;
    }
    function ee(r, t) {
      if (typeof t != "boolean")
        throw new Error("noUiSlider: 'animate' option must be a boolean.");
      r.animate = t;
    }
    function ze(r, t) {
      if (typeof t != "number")
        throw new Error("noUiSlider: 'animationDuration' option must be a number.");
      r.animationDuration = t;
    }
    function Ae(r, t) {
      var n, c = [!1];
      if (t === "lower" ? t = [!0, !1] : t === "upper" && (t = [!1, !0]), t === !0 || t === !1) {
        for (n = 1; n < r.handles; n++)
          c.push(t);
        c.push(!1);
      } else {
        if (!Array.isArray(t) || !t.length || t.length !== r.handles + 1)
          throw new Error("noUiSlider: 'connect' option doesn't match handle count.");
        c = t;
      }
      r.connect = c;
    }
    function Me(r, t) {
      switch (t) {
        case "horizontal":
          r.ort = 0;
          break;
        case "vertical":
          r.ort = 1;
          break;
        default:
          throw new Error("noUiSlider: 'orientation' option is invalid.");
      }
    }
    function re(r, t) {
      if (!C(t))
        throw new Error("noUiSlider: 'margin' option must be numeric.");
      t !== 0 && (r.margin = r.spectrum.getDistance(t));
    }
    function Ue(r, t) {
      if (!C(t))
        throw new Error("noUiSlider: 'limit' option must be numeric.");
      if (r.limit = r.spectrum.getDistance(t), !r.limit || r.handles < 2)
        throw new Error("noUiSlider: 'limit' option is only supported on linear sliders with 2 or more handles.");
    }
    function Le(r, t) {
      var n;
      if (!C(t) && !Array.isArray(t))
        throw new Error("noUiSlider: 'padding' option must be numeric or array of exactly 2 numbers.");
      if (Array.isArray(t) && t.length !== 2 && !C(t[0]) && !C(t[1]))
        throw new Error("noUiSlider: 'padding' option must be numeric or array of exactly 2 numbers.");
      if (t !== 0) {
        for (Array.isArray(t) || (t = [t, t]), r.padding = [r.spectrum.getDistance(t[0]), r.spectrum.getDistance(t[1])], n = 0; n < r.spectrum.xNumSteps.length - 1; n++)
          if (r.padding[0][n] < 0 || r.padding[1][n] < 0)
            throw new Error("noUiSlider: 'padding' option must be a positive number(s).");
        var c = t[0] + t[1], l = r.spectrum.xVal[0];
        if (c / (r.spectrum.xVal[r.spectrum.xVal.length - 1] - l) > 1)
          throw new Error("noUiSlider: 'padding' option must not exceed 100% of the range.");
      }
    }
    function Oe(r, t) {
      switch (t) {
        case "ltr":
          r.dir = 0;
          break;
        case "rtl":
          r.dir = 1;
          break;
        default:
          throw new Error("noUiSlider: 'direction' option was not recognized.");
      }
    }
    function je(r, t) {
      if (typeof t != "string")
        throw new Error("noUiSlider: 'behaviour' must be a string containing options.");
      var n = t.indexOf("tap") >= 0, c = t.indexOf("drag") >= 0, l = t.indexOf("fixed") >= 0, g = t.indexOf("snap") >= 0, N = t.indexOf("hover") >= 0, Y = t.indexOf("unconstrained") >= 0, R = t.indexOf("drag-all") >= 0, bt = t.indexOf("smooth-steps") >= 0;
      if (l) {
        if (r.handles !== 2)
          throw new Error("noUiSlider: 'fixed' behaviour must be used with 2 handles");
        re(r, r.start[1] - r.start[0]);
      }
      if (Y && (r.margin || r.limit))
        throw new Error("noUiSlider: 'unconstrained' behaviour cannot be used with margin or limit");
      r.events = { tap: n || g, drag: c, dragAll: R, smoothSteps: bt, fixed: l, snap: g, hover: N, unconstrained: Y };
    }
    function De(r, t) {
      if (t !== !1)
        if (t === !0 || O(t)) {
          r.tooltips = [];
          for (var n = 0; n < r.handles; n++)
            r.tooltips.push(t);
        } else {
          if ((t = d(t)).length !== r.handles)
            throw new Error("noUiSlider: must pass a formatter for all handles.");
          t.forEach(function(c) {
            if (typeof c != "boolean" && !O(c))
              throw new Error("noUiSlider: 'tooltips' must be passed a formatter or 'false'.");
          }), r.tooltips = t;
        }
    }
    function Fe(r, t) {
      if (t.length !== r.handles)
        throw new Error("noUiSlider: must pass a attributes for all handles.");
      r.handleAttributes = t;
    }
    function Te(r, t) {
      if (!O(t))
        throw new Error("noUiSlider: 'ariaFormat' requires 'to' method.");
      r.ariaFormat = t;
    }
    function He(r, t) {
      if (!st(t))
        throw new Error("noUiSlider: 'format' requires 'to' and 'from' methods.");
      r.format = t;
    }
    function qe(r, t) {
      if (typeof t != "boolean")
        throw new Error("noUiSlider: 'keyboardSupport' option must be a boolean.");
      r.keyboardSupport = t;
    }
    function Re(r, t) {
      r.documentElement = t;
    }
    function Be(r, t) {
      if (typeof t != "string" && t !== !1)
        throw new Error("noUiSlider: 'cssPrefix' must be a string or `false`.");
      r.cssPrefix = t;
    }
    function _e(r, t) {
      if (typeof t != "object")
        throw new Error("noUiSlider: 'cssClasses' must be an object.");
      typeof r.cssPrefix == "string" ? (r.cssClasses = {}, Object.keys(t).forEach(function(n) {
        r.cssClasses[n] = r.cssPrefix + t[n];
      })) : r.cssClasses = t;
    }
    function ie(r) {
      var t = { margin: null, limit: null, padding: null, animate: !0, animationDuration: 300, ariaFormat: St, format: St }, n = { step: { r: !1, t: dt }, keyboardPageMultiplier: { r: !1, t: vt }, keyboardMultiplier: { r: !1, t: Et }, keyboardDefaultStep: { r: !1, t: Pt }, start: { r: !0, t: v }, connect: { r: !0, t: Ae }, direction: { r: !0, t: Oe }, snap: { r: !1, t: T }, animate: { r: !1, t: ee }, animationDuration: { r: !1, t: ze }, range: { r: !0, t: it }, orientation: { r: !1, t: Me }, margin: { r: !1, t: re }, limit: { r: !1, t: Ue }, padding: { r: !1, t: Le }, behaviour: { r: !0, t: je }, ariaFormat: { r: !1, t: Te }, format: { r: !1, t: He }, tooltips: { r: !1, t: De }, keyboardSupport: { r: !0, t: qe }, documentElement: { r: !1, t: Re }, cssPrefix: { r: !0, t: Be }, cssClasses: { r: !0, t: _e }, handleAttributes: { r: !1, t: Fe } }, c = { connect: !1, direction: "ltr", behaviour: "tap", orientation: "horizontal", keyboardSupport: !0, cssPrefix: "noUi-", cssClasses: rt, keyboardPageMultiplier: 5, keyboardMultiplier: 1, keyboardDefaultStep: 10 };
      r.format && !r.ariaFormat && (r.ariaFormat = r.format), Object.keys(n).forEach(function(R) {
        if (tt(r[R]) || c[R] !== void 0)
          n[R].t(t, tt(r[R]) ? r[R] : c[R]);
        else if (n[R].r)
          throw new Error("noUiSlider: '" + R + "' is required.");
      }), t.pips = r.pips;
      var l = document.createElement("div"), g = l.style.msTransform !== void 0, N = l.style.transform !== void 0;
      t.transformRule = N ? "transform" : g ? "msTransform" : "webkitTransform";
      var Y = [["left", "top"], ["right", "bottom"]];
      return t.style = Y[t.dir][t.ort], t;
    }
    function $e(r, t, n) {
      var c, l, g, N, Y, R = ht(), bt = ot() && D(), Q = r, b = t.spectrum, xt = [], B = [], lt = [], Rt = 0, yt = {}, Vt = r.ownerDocument, Lt = t.documentElement || Vt.documentElement, Ot = Vt.body, Ye = Vt.dir === "rtl" || t.ort === 1 ? 0 : 100;
      function wt(e, i) {
        var o = Vt.createElement("div");
        return i && m(o, i), e.appendChild(o), o;
      }
      function Xe(e, i) {
        var o = wt(e, t.cssClasses.origin), a = wt(o, t.cssClasses.handle);
        if (wt(a, t.cssClasses.touchArea), a.setAttribute("data-handle", String(i)), t.keyboardSupport && (a.setAttribute("tabindex", "0"), a.addEventListener("keydown", function(s) {
          return sr(s, i);
        })), t.handleAttributes !== void 0) {
          var u = t.handleAttributes[i];
          Object.keys(u).forEach(function(s) {
            a.setAttribute(s, u[s]);
          });
        }
        return a.setAttribute("role", "slider"), a.setAttribute("aria-orientation", t.ort ? "vertical" : "horizontal"), i === 0 ? m(a, t.cssClasses.handleLower) : i === t.handles - 1 && m(a, t.cssClasses.handleUpper), o;
      }
      function ae(e, i) {
        return !!i && wt(e, t.cssClasses.connect);
      }
      function Ke(e, i) {
        var o = wt(i, t.cssClasses.connects);
        l = [], (g = []).push(ae(o, e[0]));
        for (var a = 0; a < t.handles; a++)
          l.push(Xe(i, a)), lt[a] = a, g.push(ae(o, e[a + 1]));
      }
      function We(e) {
        return m(e, t.cssClasses.target), t.dir === 0 ? m(e, t.cssClasses.ltr) : m(e, t.cssClasses.rtl), t.ort === 0 ? m(e, t.cssClasses.horizontal) : m(e, t.cssClasses.vertical), m(e, getComputedStyle(e).direction === "rtl" ? t.cssClasses.textDirectionRtl : t.cssClasses.textDirectionLtr), wt(e, t.cssClasses.base);
      }
      function Ge(e, i) {
        return !(!t.tooltips || !t.tooltips[i]) && wt(e.firstChild, t.cssClasses.tooltip);
      }
      function ne() {
        return Q.hasAttribute("disabled");
      }
      function Bt(e) {
        return l[e].hasAttribute("disabled");
      }
      function _t() {
        Y && (Mt("update" + I.tooltips), Y.forEach(function(e) {
          e && ft(e);
        }), Y = null);
      }
      function se() {
        _t(), Y = l.map(Ge), Kt("update" + I.tooltips, function(e, i, o) {
          if (Y && t.tooltips && Y[i] !== !1) {
            var a = e[i];
            t.tooltips[i] !== !0 && (a = t.tooltips[i].to(o[i])), Y[i].innerHTML = a;
          }
        });
      }
      function Je() {
        Mt("update" + I.aria), Kt("update" + I.aria, function(e, i, o, a, u) {
          lt.forEach(function(s) {
            var y = l[s], p = jt(B, s, 0, !0, !0, !0), K = jt(B, s, 100, !0, !0, !0), _ = u[s], z = String(t.ariaFormat.to(o[s]));
            p = b.fromStepping(p).toFixed(1), K = b.fromStepping(K).toFixed(1), _ = b.fromStepping(_).toFixed(1), y.children[0].setAttribute("aria-valuemin", p), y.children[0].setAttribute("aria-valuemax", K), y.children[0].setAttribute("aria-valuenow", _), y.children[0].setAttribute("aria-valuetext", z);
          });
        });
      }
      function Qe(e) {
        if (e.mode === f.PipsMode.Range || e.mode === f.PipsMode.Steps)
          return b.xVal;
        if (e.mode === f.PipsMode.Count) {
          if (e.values < 2)
            throw new Error("noUiSlider: 'values' (>= 2) required for mode 'count'.");
          for (var i = e.values - 1, o = 100 / i, a = []; i--; )
            a[i] = i * o;
          return a.push(100), le(a, e.stepped);
        }
        return e.mode === f.PipsMode.Positions ? le(e.values, e.stepped) : e.mode === f.PipsMode.Values ? e.stepped ? e.values.map(function(u) {
          return b.fromStepping(b.getStep(b.toStepping(u)));
        }) : e.values : [];
      }
      function le(e, i) {
        return e.map(function(o) {
          return b.fromStepping(i ? b.getStep(o) : o);
        });
      }
      function Ze(e) {
        function i(_, z) {
          return Number((_ + z).toFixed(7));
        }
        var o = Qe(e), a = {}, u = b.xVal[0], s = b.xVal[b.xVal.length - 1], y = !1, p = !1, K = 0;
        return (o = M(o.slice().sort(function(_, z) {
          return _ - z;
        })))[0] !== u && (o.unshift(u), y = !0), o[o.length - 1] !== s && (o.push(s), p = !0), o.forEach(function(_, z) {
          var L, P, Z, nt, G, ge, Jt, be, xe, ye, Qt = _, zt = o[z + 1], we = e.mode === f.PipsMode.Steps;
          for (we && (L = b.xNumSteps[z]), L || (L = zt - Qt), zt === void 0 && (zt = Qt), L = Math.max(L, 1e-7), P = Qt; P <= zt; P = i(P, L)) {
            for (be = (G = (nt = b.toStepping(P)) - K) / (e.density || 1), ye = G / (xe = Math.round(be)), Z = 1; Z <= xe; Z += 1)
              a[(ge = K + Z * ye).toFixed(5)] = [b.fromStepping(ge), 0];
            Jt = o.indexOf(P) > -1 ? f.PipsType.LargeValue : we ? f.PipsType.SmallValue : f.PipsType.NoValue, !z && y && P !== zt && (Jt = 0), P === zt && p || (a[nt.toFixed(5)] = [P, Jt]), K = nt;
          }
        }), a;
      }
      function tr(e, i, o) {
        var a, u, s = Vt.createElement("div"), y = ((a = {})[f.PipsType.None] = "", a[f.PipsType.NoValue] = t.cssClasses.valueNormal, a[f.PipsType.LargeValue] = t.cssClasses.valueLarge, a[f.PipsType.SmallValue] = t.cssClasses.valueSub, a), p = ((u = {})[f.PipsType.None] = "", u[f.PipsType.NoValue] = t.cssClasses.markerNormal, u[f.PipsType.LargeValue] = t.cssClasses.markerLarge, u[f.PipsType.SmallValue] = t.cssClasses.markerSub, u), K = [t.cssClasses.valueHorizontal, t.cssClasses.valueVertical], _ = [t.cssClasses.markerHorizontal, t.cssClasses.markerVertical];
        function z(P, Z) {
          var nt = Z === t.cssClasses.value, G = nt ? y : p;
          return Z + " " + (nt ? K : _)[t.ort] + " " + G[P];
        }
        function L(P, Z, nt) {
          if ((nt = i ? i(Z, nt) : nt) !== f.PipsType.None) {
            var G = wt(s, !1);
            G.className = z(nt, t.cssClasses.marker), G.style[t.style] = P + "%", nt > f.PipsType.NoValue && ((G = wt(s, !1)).className = z(nt, t.cssClasses.value), G.setAttribute("data-value", String(Z)), G.style[t.style] = P + "%", G.innerHTML = String(o.to(Z)));
          }
        }
        return m(s, t.cssClasses.pips), m(s, t.ort === 0 ? t.cssClasses.pipsHorizontal : t.cssClasses.pipsVertical), Object.keys(e).forEach(function(P) {
          L(P, e[P][0], e[P][1]);
        }), s;
      }
      function $t() {
        N && (ft(N), N = null);
      }
      function It(e) {
        $t();
        var i = Ze(e), o = e.filter, a = e.format || { to: function(u) {
          return String(Math.round(u));
        } };
        return N = Q.appendChild(tr(i, o, a));
      }
      function ue() {
        var e = c.getBoundingClientRect(), i = "offset" + ["Width", "Height"][t.ort];
        return t.ort === 0 ? e.width || c[i] : e.height || c[i];
      }
      function Ct(e, i, o, a) {
        var u = function(y) {
          var p = er(y, a.pageOffset, a.target || i);
          return !!p && !(ne() && !a.doNotReject) && !(k(Q, t.cssClasses.tap) && !a.doNotReject) && !(e === R.start && p.buttons !== void 0 && p.buttons > 1) && (!a.hover || !p.buttons) && (bt || p.preventDefault(), p.calcPoint = p.points[t.ort], void o(p, a));
        }, s = [];
        return e.split(" ").forEach(function(y) {
          i.addEventListener(y, u, !!bt && { passive: !0 }), s.push([y, u]);
        }), s;
      }
      function er(e, i, o) {
        var a = e.type.indexOf("touch") === 0, u = e.type.indexOf("mouse") === 0, s = e.type.indexOf("pointer") === 0, y = 0, p = 0;
        if (e.type.indexOf("MSPointer") === 0 && (s = !0), e.type === "mousedown" && !e.buttons && !e.touches)
          return !1;
        if (a) {
          var K = function(L) {
            var P = L.target;
            return P === o || o.contains(P) || e.composed && e.composedPath().shift() === o;
          };
          if (e.type === "touchstart") {
            var _ = Array.prototype.filter.call(e.touches, K);
            if (_.length > 1)
              return !1;
            y = _[0].pageX, p = _[0].pageY;
          } else {
            var z = Array.prototype.find.call(e.changedTouches, K);
            if (!z)
              return !1;
            y = z.pageX, p = z.pageY;
          }
        }
        return i = i || mt(Vt), (u || s) && (y = e.clientX + i.x, p = e.clientY + i.y), e.pageOffset = i, e.points = [y, p], e.cursor = u || s, e;
      }
      function de(e) {
        var i = 100 * (e - $(c, t.ort)) / ue();
        return i = j(i), t.dir ? 100 - i : i;
      }
      function rr(e) {
        var i = 100, o = !1;
        return l.forEach(function(a, u) {
          if (!Bt(u)) {
            var s = B[u], y = Math.abs(s - e);
            (y < i || y <= i && e > s || y === 100 && i === 100) && (o = u, i = y);
          }
        }), o;
      }
      function ir(e, i) {
        e.type === "mouseout" && e.target.nodeName === "HTML" && e.relatedTarget === null && Yt(e, i);
      }
      function or(e, i) {
        if (navigator.appVersion.indexOf("MSIE 9") === -1 && e.buttons === 0 && i.buttonsProperty !== 0)
          return Yt(e, i);
        var o = (t.dir ? -1 : 1) * (e.calcPoint - i.startCalcPoint);
        pe(o > 0, 100 * o / i.baseSize, i.locations, i.handleNumbers, i.connect);
      }
      function Yt(e, i) {
        i.handle && (E(i.handle, t.cssClasses.active), Rt -= 1), i.listeners.forEach(function(o) {
          Lt.removeEventListener(o[0], o[1]);
        }), Rt === 0 && (E(Q, t.cssClasses.drag), Gt(), e.cursor && (Ot.style.cursor = "", Ot.removeEventListener("selectstart", S))), t.events.smoothSteps && (i.handleNumbers.forEach(function(o) {
          Nt(o, B[o], !0, !0, !1, !1);
        }), i.handleNumbers.forEach(function(o) {
          X("update", o);
        })), i.handleNumbers.forEach(function(o) {
          X("change", o), X("set", o), X("end", o);
        });
      }
      function Xt(e, i) {
        if (!i.handleNumbers.some(Bt)) {
          var o;
          i.handleNumbers.length === 1 && (o = l[i.handleNumbers[0]].children[0], Rt += 1, m(o, t.cssClasses.active)), e.stopPropagation();
          var a = [], u = Ct(R.move, Lt, or, { target: e.target, handle: o, connect: i.connect, listeners: a, startCalcPoint: e.calcPoint, baseSize: ue(), pageOffset: e.pageOffset, handleNumbers: i.handleNumbers, buttonsProperty: e.buttons, locations: B.slice() }), s = Ct(R.end, Lt, Yt, { target: e.target, handle: o, listeners: a, doNotReject: !0, handleNumbers: i.handleNumbers }), y = Ct("mouseout", Lt, ir, { target: e.target, handle: o, listeners: a, doNotReject: !0, handleNumbers: i.handleNumbers });
          a.push.apply(a, u.concat(s, y)), e.cursor && (Ot.style.cursor = getComputedStyle(e.target).cursor, l.length > 1 && m(Q, t.cssClasses.drag), Ot.addEventListener("selectstart", S, !1)), i.handleNumbers.forEach(function(p) {
            X("start", p);
          });
        }
      }
      function ar(e) {
        e.stopPropagation();
        var i = de(e.calcPoint), o = rr(i);
        o !== !1 && (t.events.snap || U(Q, t.cssClasses.tap, t.animationDuration), Nt(o, i, !0, !0), Gt(), X("slide", o, !0), X("update", o, !0), t.events.snap ? Xt(e, { handleNumbers: [o] }) : (X("change", o, !0), X("set", o, !0)));
      }
      function nr(e) {
        var i = de(e.calcPoint), o = b.getStep(i), a = b.fromStepping(o);
        Object.keys(yt).forEach(function(u) {
          u.split(".")[0] === "hover" && yt[u].forEach(function(s) {
            s.call(Ft, a);
          });
        });
      }
      function sr(e, i) {
        if (ne() || Bt(i))
          return !1;
        var o = ["Left", "Right"], a = ["Down", "Up"], u = ["PageDown", "PageUp"], s = ["Home", "End"];
        t.dir && !t.ort ? o.reverse() : t.ort && !t.dir && (a.reverse(), u.reverse());
        var y, p = e.key.replace("Arrow", ""), K = p === u[0], _ = p === u[1], z = p === a[0] || p === o[0] || K, L = p === a[1] || p === o[1] || _, P = p === s[0], Z = p === s[1];
        if (!(z || L || P || Z))
          return !0;
        if (e.preventDefault(), L || z) {
          var nt = z ? 0 : 1, G = ve(i)[nt];
          if (G === null)
            return !1;
          G === !1 && (G = b.getDefaultStep(B[i], z, t.keyboardDefaultStep)), G *= _ || K ? t.keyboardPageMultiplier : t.keyboardMultiplier, G = Math.max(G, 1e-7), G *= z ? -1 : 1, y = xt[i] + G;
        } else
          y = Z ? t.spectrum.xVal[t.spectrum.xVal.length - 1] : t.spectrum.xVal[0];
        return Nt(i, b.toStepping(y), !0, !0), X("slide", i), X("update", i), X("change", i), X("set", i), !1;
      }
      function lr(e) {
        e.fixed || l.forEach(function(i, o) {
          Ct(R.start, i.children[0], Xt, { handleNumbers: [o] });
        }), e.tap && Ct(R.start, c, ar, {}), e.hover && Ct(R.move, c, nr, { hover: !0 }), e.drag && g.forEach(function(i, o) {
          if (i !== !1 && o !== 0 && o !== g.length - 1) {
            var a = l[o - 1], u = l[o], s = [i], y = [a, u], p = [o - 1, o];
            m(i, t.cssClasses.draggable), e.fixed && (s.push(a.children[0]), s.push(u.children[0])), e.dragAll && (y = l, p = lt), s.forEach(function(K) {
              Ct(R.start, K, Xt, { handles: y, handleNumbers: p, connect: i });
            });
          }
        });
      }
      function Kt(e, i) {
        yt[e] = yt[e] || [], yt[e].push(i), e.split(".")[0] === "update" && l.forEach(function(o, a) {
          X("update", a);
        });
      }
      function ur(e) {
        return e === I.aria || e === I.tooltips;
      }
      function Mt(e) {
        var i = e && e.split(".")[0], o = i ? e.substring(i.length) : e;
        Object.keys(yt).forEach(function(a) {
          var u = a.split(".")[0], s = a.substring(u.length);
          i && i !== u || o && o !== s || ur(s) && o !== s || delete yt[a];
        });
      }
      function X(e, i, o) {
        Object.keys(yt).forEach(function(a) {
          var u = a.split(".")[0];
          e === u && yt[a].forEach(function(s) {
            s.call(Ft, xt.map(t.format.to), i, xt.slice(), o || !1, B.slice(), Ft);
          });
        });
      }
      function jt(e, i, o, a, u, s, y) {
        var p;
        return l.length > 1 && !t.events.unconstrained && (a && i > 0 && (p = b.getAbsoluteDistance(e[i - 1], t.margin, !1), o = Math.max(o, p)), u && i < l.length - 1 && (p = b.getAbsoluteDistance(e[i + 1], t.margin, !0), o = Math.min(o, p))), l.length > 1 && t.limit && (a && i > 0 && (p = b.getAbsoluteDistance(e[i - 1], t.limit, !1), o = Math.min(o, p)), u && i < l.length - 1 && (p = b.getAbsoluteDistance(e[i + 1], t.limit, !0), o = Math.max(o, p))), t.padding && (i === 0 && (p = b.getAbsoluteDistance(0, t.padding[0], !1), o = Math.max(o, p)), i === l.length - 1 && (p = b.getAbsoluteDistance(100, t.padding[1], !0), o = Math.min(o, p))), y || (o = b.getStep(o)), !((o = j(o)) === e[i] && !s) && o;
      }
      function Wt(e, i) {
        var o = t.ort;
        return (o ? i : e) + ", " + (o ? e : i);
      }
      function pe(e, i, o, a, u) {
        var s = o.slice(), y = a[0], p = t.events.smoothSteps, K = [!e, e], _ = [e, !e];
        a = a.slice(), e && a.reverse(), a.length > 1 ? a.forEach(function(L, P) {
          var Z = jt(s, L, s[L] + i, K[P], _[P], !1, p);
          Z === !1 ? i = 0 : (i = Z - s[L], s[L] = Z);
        }) : K = _ = [!0];
        var z = !1;
        a.forEach(function(L, P) {
          z = Nt(L, o[L] + i, K[P], _[P], !1, p) || z;
        }), z && (a.forEach(function(L) {
          X("update", L), X("slide", L);
        }), u != null && X("drag", y));
      }
      function ce(e, i) {
        return t.dir ? 100 - e - i : e;
      }
      function dr(e, i) {
        B[e] = i, xt[e] = b.fromStepping(i);
        var o = "translate(" + Wt(ce(i, 0) - Ye + "%", "0") + ")";
        l[e].style[t.transformRule] = o, he(e), he(e + 1);
      }
      function Gt() {
        lt.forEach(function(e) {
          var i = B[e] > 50 ? -1 : 1, o = 3 + (l.length + i * e);
          l[e].style.zIndex = String(o);
        });
      }
      function Nt(e, i, o, a, u, s) {
        return u || (i = jt(B, e, i, o, a, !1, s)), i !== !1 && (dr(e, i), !0);
      }
      function he(e) {
        if (g[e]) {
          var i = 0, o = 100;
          e !== 0 && (i = B[e - 1]), e !== g.length - 1 && (o = B[e]);
          var a = o - i, u = "translate(" + Wt(ce(i, a) + "%", "0") + ")", s = "scale(" + Wt(a / 100, "1") + ")";
          g[e].style[t.transformRule] = u + " " + s;
        }
      }
      function fe(e, i) {
        return e === null || e === !1 || e === void 0 ? B[i] : (typeof e == "number" && (e = String(e)), (e = t.format.from(e)) !== !1 && (e = b.toStepping(e)), e === !1 || isNaN(e) ? B[i] : e);
      }
      function Dt(e, i, o) {
        var a = d(e), u = B[0] === void 0;
        i = i === void 0 || i, t.animate && !u && U(Q, t.cssClasses.tap, t.animationDuration), lt.forEach(function(p) {
          Nt(p, fe(a[p], p), !0, !1, o);
        });
        var s = lt.length === 1 ? 0 : 1;
        if (u && b.hasNoSize() && (o = !0, B[0] = 0, lt.length > 1)) {
          var y = 100 / (lt.length - 1);
          lt.forEach(function(p) {
            B[p] = p * y;
          });
        }
        for (; s < lt.length; ++s)
          lt.forEach(function(p) {
            Nt(p, B[p], !0, !0, o);
          });
        Gt(), lt.forEach(function(p) {
          X("update", p), a[p] !== null && i && X("set", p);
        });
      }
      function pr(e) {
        Dt(t.start, e);
      }
      function cr(e, i, o, a) {
        if (!((e = Number(e)) >= 0 && e < lt.length))
          throw new Error("noUiSlider: invalid handle number, got: " + e);
        Nt(e, fe(i, e), !0, !0, a), X("update", e), o && X("set", e);
      }
      function me(e) {
        if (e === void 0 && (e = !1), e)
          return xt.length === 1 ? xt[0] : xt.slice(0);
        var i = xt.map(t.format.to);
        return i.length === 1 ? i[0] : i;
      }
      function hr() {
        for (Mt(I.aria), Mt(I.tooltips), Object.keys(t.cssClasses).forEach(function(e) {
          E(Q, t.cssClasses[e]);
        }); Q.firstChild; )
          Q.removeChild(Q.firstChild);
        delete Q.noUiSlider;
      }
      function ve(e) {
        var i = B[e], o = b.getNearbySteps(i), a = xt[e], u = o.thisStep.step, s = null;
        if (t.snap)
          return [a - o.stepBefore.startValue || null, o.stepAfter.startValue - a || null];
        u !== !1 && a + u > o.stepAfter.startValue && (u = o.stepAfter.startValue - a), s = a > o.thisStep.startValue ? o.thisStep.step : o.stepBefore.step !== !1 && a - o.stepBefore.highestStep, i === 100 ? u = null : i === 0 && (s = null);
        var y = b.countStepDecimals();
        return u !== null && u !== !1 && (u = Number(u.toFixed(y))), s !== null && s !== !1 && (s = Number(s.toFixed(y))), [s, u];
      }
      function fr() {
        return lt.map(ve);
      }
      function mr(e, i) {
        var o = me(), a = ["margin", "limit", "padding", "range", "animate", "snap", "step", "format", "pips", "tooltips"];
        a.forEach(function(s) {
          e[s] !== void 0 && (n[s] = e[s]);
        });
        var u = ie(n);
        a.forEach(function(s) {
          e[s] !== void 0 && (t[s] = u[s]);
        }), b = u.spectrum, t.margin = u.margin, t.limit = u.limit, t.padding = u.padding, t.pips ? It(t.pips) : $t(), t.tooltips ? se() : _t(), B = [], Dt(tt(e.start) ? e.start : o, i);
      }
      function vr() {
        c = We(Q), Ke(t.connect, c), lr(t.events), Dt(t.start), t.pips && It(t.pips), t.tooltips && se(), Je();
      }
      vr();
      var Ft = { destroy: hr, steps: fr, on: Kt, off: Mt, get: me, set: Dt, setHandle: cr, reset: pr, __moveHandles: function(e, i, o) {
        pe(e, i, B, o);
      }, options: n, updateOptions: mr, target: Q, removePips: $t, removeTooltips: _t, getPositions: function() {
        return B.slice();
      }, getTooltips: function() {
        return Y;
      }, getOrigins: function() {
        return l;
      }, pips: It };
      return Ft;
    }
    function oe(r, t) {
      if (!r || !r.nodeName)
        throw new Error("noUiSlider: create requires a single element, got: " + r);
      if (r.noUiSlider)
        throw new Error("noUiSlider: Slider was already initialized.");
      var n = $e(r, ie(t), t);
      return r.noUiSlider = n, n;
    }
    var Ie = { __spectrum: kt, cssClasses: rt, create: oe };
    f.create = oe, f.cssClasses = rt, f.default = Ie, Object.defineProperty(f, "__esModule", { value: !0 });
  })(A);
}));
function Ce(V, A) {
  if (!Array.isArray(V) || !Array.isArray(A))
    return !1;
  const f = A.slice().sort();
  return V.length === A.length && V.slice().sort().every(function(st, O) {
    return st === f[O];
  });
}
var te = { name: "Slider", emits: ["input", "update:modelValue", "start", "slide", "drag", "update", "change", "set", "end"], props: { value: { validator: function(V) {
  return (A) => typeof A == "number" || A instanceof Array || A == null || A === !1;
}, required: !1 }, modelValue: { validator: function(V) {
  return (A) => typeof A == "number" || A instanceof Array || A == null || A === !1;
}, required: !1 }, id: { type: [String, Number], required: !1 }, disabled: { type: Boolean, required: !1, default: !1 }, min: { type: Number, required: !1, default: 0 }, max: { type: Number, required: !1, default: 100 }, step: { type: Number, required: !1, default: 1 }, orientation: { type: String, required: !1, default: "horizontal" }, direction: { type: String, required: !1, default: "ltr" }, tooltips: { type: Boolean, required: !1, default: !0 }, options: { type: Object, required: !1, default: () => ({}) }, merge: { type: Number, required: !1, default: -1 }, format: { type: [Object, Function, Boolean], required: !1, default: null }, classes: { type: Object, required: !1, default: () => ({}) }, showTooltip: { type: String, required: !1, default: "always" }, tooltipPosition: { type: String, required: !1, default: null }, lazy: { type: Boolean, required: !1, default: !0 }, ariaLabelledby: { type: String, required: !1, default: void 0 }, aria: { required: !1, type: Object, default: () => ({}) } }, setup(V, A) {
  const f = function(tt, S, M) {
    const { value: H, modelValue: $, min: C } = Tt(tt);
    let U = $ && $.value !== void 0 ? $ : H;
    const j = Ut(U.value);
    if (Ht(U.value) && (U = Ut(C.value)), Array.isArray(U.value) && U.value.length == 0)
      throw new Error("Slider v-model must not be an empty array");
    return { value: U, initialValue: j };
  }(V), st = function(tt, S, M) {
    const { classes: H, showTooltip: $, tooltipPosition: C, orientation: U } = Tt(tt), j = gt(() => ({ target: "slider-target", focused: "slider-focused", tooltipFocus: "slider-tooltip-focus", tooltipDrag: "slider-tooltip-drag", ltr: "slider-ltr", rtl: "slider-rtl", horizontal: "slider-horizontal", vertical: "slider-vertical", textDirectionRtl: "slider-txt-dir-rtl", textDirectionLtr: "slider-txt-dir-ltr", base: "slider-base", connects: "slider-connects", connect: "slider-connect", origin: "slider-origin", handle: "slider-handle", handleLower: "slider-handle-lower", handleUpper: "slider-handle-upper", touchArea: "slider-touch-area", tooltip: "slider-tooltip", tooltipTop: "slider-tooltip-top", tooltipBottom: "slider-tooltip-bottom", tooltipLeft: "slider-tooltip-left", tooltipRight: "slider-tooltip-right", tooltipHidden: "slider-tooltip-hidden", active: "slider-active", draggable: "slider-draggable", tap: "slider-state-tap", drag: "slider-state-drag", pips: "slider-pips", pipsHorizontal: "slider-pips-horizontal", pipsVertical: "slider-pips-vertical", marker: "slider-marker", markerHorizontal: "slider-marker-horizontal", markerVertical: "slider-marker-vertical", markerNormal: "slider-marker-normal", markerLarge: "slider-marker-large", markerSub: "slider-marker-sub", value: "slider-value", valueHorizontal: "slider-value-horizontal", valueVertical: "slider-value-vertical", valueNormal: "slider-value-normal", valueLarge: "slider-value-large", valueSub: "slider-value-sub", ...H.value }));
    return { classList: gt(() => {
      const d = { ...j.value };
      return Object.keys(d).forEach((h) => {
        d[h] = Array.isArray(d[h]) ? d[h].filter((m) => m !== null).join(" ") : d[h];
      }), $.value !== "always" && (d.target += ` ${$.value === "drag" ? d.tooltipDrag : d.tooltipFocus}`), U.value === "horizontal" && (d.tooltip += C.value === "bottom" ? ` ${d.tooltipBottom}` : ` ${d.tooltipTop}`), U.value === "vertical" && (d.tooltip += C.value === "right" ? ` ${d.tooltipRight}` : ` ${d.tooltipLeft}`), d;
    }) };
  }(V), O = function(tt, S, M) {
    const { format: H, step: $ } = Tt(tt), C = M.value, U = M.classList, j = gt(() => H && H.value ? typeof H.value == "function" ? { to: H.value } : Pe({ ...H.value }) : Pe({ decimals: $.value >= 0 ? 0 : 2 })), d = gt(() => Array.isArray(C.value) ? C.value.map((h) => j.value) : j.value);
    return { tooltipFormat: j, tooltipsFormat: d, tooltipsMerge: (h, m, E) => {
      var k = getComputedStyle(h).direction === "rtl", mt = h.noUiSlider.options.direction === "rtl", ht = h.noUiSlider.options.orientation === "vertical", D = h.noUiSlider.getTooltips(), ot = h.noUiSlider.getOrigins();
      D.forEach(function(W, q) {
        W && ot[q].appendChild(W);
      }), h.noUiSlider.on("update", function(W, q, x, ct, F) {
        var at = [[]], ut = [[]], et = [[]], w = 0;
        D[0] && (at[0][0] = 0, ut[0][0] = F[0], et[0][0] = j.value.to(parseFloat(W[0])));
        for (var J = 1; J < W.length; J++)
          (!D[J] || W[J] - W[J - 1] > m) && (at[++w] = [], et[w] = [], ut[w] = []), D[J] && (at[w].push(J), et[w].push(j.value.to(parseFloat(W[J]))), ut[w].push(F[J]));
        at.forEach(function(kt, St) {
          for (var rt = kt.length, I = 0; I < rt; I++) {
            var dt = kt[I];
            if (I === rt - 1) {
              var vt = 0;
              ut[St].forEach(function(v) {
                vt += 1e3 - v;
              });
              var Et = ht ? "bottom" : "right", Pt = mt ? 0 : rt - 1, it = 1e3 - ut[St][Pt];
              vt = (k && !ht ? 100 : 0) + vt / rt - it, D[dt].innerHTML = et[St].join(E), D[dt].style.display = "block", D[dt].style[Et] = vt + "%", U.value.tooltipHidden.split(" ").forEach((v) => {
                D[dt].classList.contains(v) && D[dt].classList.remove(v);
              });
            } else
              D[dt].style.display = "none", U.value.tooltipHidden.split(" ").forEach((v) => {
                D[dt].classList.add(v);
              });
          }
        });
      });
    } };
  }(V, 0, { value: f.value, classList: st.classList }), ft = function(tt, S, M) {
    const { orientation: H, direction: $, tooltips: C, step: U, min: j, max: d, merge: h, id: m, disabled: E, options: k, classes: mt, format: ht, lazy: D, ariaLabelledby: ot, aria: W } = Tt(tt), q = M.value, x = M.initialValue, ct = M.tooltipsFormat, F = M.tooltipsMerge, at = M.tooltipFormat, ut = M.classList, et = Ut(null), w = Ut(null), J = Ut(!1), kt = gt(() => {
      let v = { cssPrefix: "", cssClasses: ut.value, orientation: H.value, direction: $.value, tooltips: !!C.value && ct.value, connect: "lower", start: Ht(q.value) ? j.value : q.value, range: { min: j.value, max: d.value } };
      if (U.value > 0 && (v.step = U.value), Array.isArray(q.value) && (v.connect = !0), ot && ot.value || W && Object.keys(W.value).length) {
        let T = Array.isArray(q.value) ? q.value : [q.value];
        v.handleAttributes = T.map((ee) => Object.assign({}, W.value, ot && ot.value ? { "aria-labelledby": ot.value } : {}));
      }
      return ht.value && (v.ariaFormat = at.value), v;
    }), St = gt(() => {
      let v = { id: m && m.value ? m.value : void 0 };
      return E.value && (v.disabled = !0), v;
    }), rt = gt(() => Array.isArray(q.value)), I = () => {
      let v = w.value.get();
      return Array.isArray(v) ? v.map((T) => parseFloat(T)) : parseFloat(v);
    }, dt = function(v) {
      let T = !(arguments.length > 1 && arguments[1] !== void 0) || arguments[1];
      w.value.set(v, T);
    }, vt = (v) => {
      S.emit("input", v), S.emit("update:modelValue", v), S.emit("update", v);
    }, Et = () => {
      w.value = Mr.create(et.value, Object.assign({}, kt.value, k.value)), C.value && rt.value && h.value >= 0 && F(et.value, h.value, " - "), w.value.on("set", () => {
        const v = I();
        S.emit("change", v), S.emit("set", v), D.value && vt(v);
      }), w.value.on("update", () => {
        if (!J.value)
          return;
        const v = I();
        rt.value && Ce(q.value, v) || !rt.value && q.value == v ? S.emit("update", v) : D.value || vt(v);
      }), w.value.on("start", () => {
        S.emit("start", I());
      }), w.value.on("end", () => {
        S.emit("end", I());
      }), w.value.on("slide", () => {
        S.emit("slide", I());
      }), w.value.on("drag", () => {
        S.emit("drag", I());
      }), et.value.querySelectorAll("[data-handle]").forEach((v) => {
        v.onblur = () => {
          et.value && ut.value.focused.split(" ").forEach((T) => {
            et.value.classList.remove(T);
          });
        }, v.onfocus = () => {
          ut.value.focused.split(" ").forEach((T) => {
            et.value.classList.add(T);
          });
        };
      }), J.value = !0;
    }, Pt = () => {
      w.value.off(), w.value.destroy(), w.value = null;
    }, it = (v, T) => {
      J.value = !1, Pt(), Et();
    };
    return gr(Et), br(Pt), pt(rt, it, { immediate: !1 }), pt(j, it, { immediate: !1 }), pt(d, it, { immediate: !1 }), pt(U, it, { immediate: !1 }), pt(H, it, { immediate: !1 }), pt($, it, { immediate: !1 }), pt(C, it, { immediate: !1 }), pt(h, it, { immediate: !1 }), pt(ht, it, { immediate: !1, deep: !0 }), pt(k, it, { immediate: !1, deep: !0 }), pt(mt, it, { immediate: !1, deep: !0 }), pt(q, (v, T) => {
      T && (typeof T == "object" && typeof v == "object" && v && Object.keys(T) > Object.keys(v) || typeof T == "object" && typeof v != "object" || Ht(v)) && it();
    }, { immediate: !1 }), pt(q, (v) => {
      if (Ht(v))
        return void dt(j.value, !1);
      let T = I();
      rt.value && !Array.isArray(T) && (T = [T]), (rt.value && !Ce(v, T) || !rt.value && v != T) && dt(v, !1);
    }, { deep: !0 }), { slider: et, slider$: w, isRange: rt, sliderProps: St, init: Et, destroy: Pt, refresh: it, update: dt, reset: () => {
      vt(x.value);
    } };
  }(V, A, { value: f.value, initialValue: f.initialValue, tooltipFormat: O.tooltipFormat, tooltipsFormat: O.tooltipsFormat, tooltipsMerge: O.tooltipsMerge, classList: st.classList });
  return { ...st, ...O, ...ft };
} };
te.render = function(V, A, f, st, O, ft) {
  return qt(), Zt("div", Ne(V.sliderProps, { ref: "slider" }), null, 16);
}, te.__file = "src/Slider.vue";
const Ur = `.slider-target,.slider-target *{-webkit-touch-callout:none;-webkit-tap-highlight-color:rgba(0,0,0,0);box-sizing:border-box;touch-action:none;-webkit-user-select:none;user-select:none}.slider-target{position:relative}.slider-base,.slider-connects{height:100%;position:relative;width:100%;z-index:1}.slider-connects{overflow:hidden;z-index:0}.slider-connect,.slider-origin{height:100%;position:absolute;right:0;top:0;transform-origin:0 0;transform-style:flat;width:100%;will-change:transform;z-index:1}.slider-txt-dir-rtl.slider-horizontal .slider-origin{left:0;right:auto}.slider-vertical .slider-origin{top:-100%;width:0}.slider-horizontal .slider-origin{height:0}.slider-handle{backface-visibility:hidden;position:absolute}.slider-touch-area{height:100%;width:100%}.slider-state-tap .slider-connect,.slider-state-tap .slider-origin{transition:transform .3s}.slider-state-drag *{cursor:inherit!important}.slider-tooltip-drag .slider-tooltip,.slider-tooltip-focus .slider-tooltip{display:none!important}.slider-tooltip-drag .slider-active .slider-tooltip,.slider-tooltip-drag.slider-state-drag .slider-tooltip:not(.slider-tooltip-hidden),.slider-tooltip-focus.slider-focused .slider-tooltip:not(.slider-tooltip-hidden){display:block!important}.slider-horizontal{height:var(--slider-height,6px)}.slider-horizontal .slider-handle{height:var(--slider-handle-height,16px);right:calc(var(--slider-handle-width, 16px)/2*-1);top:calc((var(--slider-handle-height, 16px) - var(--slider-height, 6px))/2*-1 + -1px);width:var(--slider-handle-width,16px)}.slider-vertical{height:var(--slider-vertical-height,300px);width:var(--slider-height,6px)}.slider-vertical .slider-handle{bottom:calc(var(--slider-handle-width, 16px)/2*-1);height:var(--slider-handle-width,16px);right:calc((var(--slider-handle-height, 16px) - var(--slider-height, 6px))/2*-1 + -1px);width:var(--slider-handle-height,16px)}.slider-txt-dir-rtl.slider-horizontal .slider-handle{left:calc(var(--slider-handle-width, 16px)/2*-1);right:auto}.slider-base{background-color:var(--slider-bg,#d1d5db)}.slider-base,.slider-connects{border-radius:var(--slider-radius,9999px)}.slider-connect{background:var(--slider-connect-bg,#10b981);cursor:pointer}.slider-draggable{cursor:ew-resize}.slider-vertical .slider-draggable{cursor:ns-resize}.slider-handle{background:var(--slider-handle-bg,#fff);border:var(--slider-handle-border,0);border-radius:var(--slider-handle-radius,9999px);box-shadow:var(--slider-handle-shadow,.5px .5px 2px 1px rgba(0,0,0,.32));cursor:grab;height:var(--slider-handle-height,16px);width:var(--slider-handle-width,16px)}.slider-handle:focus{box-shadow:0 0 0 var(--slider-handle-ring-width,3px) var(--slider-handle-ring-color,rgba(16,185,129,.188)),var(--slider-handle-shadow,.5px .5px 2px 1px rgba(0,0,0,.32));outline:none}.slider-active{box-shadow:var(--slider-handle-shadow-active,.5px .5px 2px 1px rgba(0,0,0,.42));cursor:grabbing}[disabled] .slider-connect{background:var(--slider-connect-bg-disabled,#9ca3af)}[disabled] .slider-handle,[disabled].slider-handle,[disabled].slider-target{cursor:not-allowed}[disabled] .slider-tooltip{background:var(--slider-tooltip-bg-disabled,#9ca3af);border-color:var(--slider-tooltip-bg-disabled,#9ca3af)}.slider-tooltip{background:var(--slider-tooltip-bg,#10b981);border:1px solid var(--slider-tooltip-bg,#10b981);border-radius:var(--slider-tooltip-radius,5px);color:var(--slider-tooltip-color,#fff);display:block;font-size:var(--slider-tooltip-font-size,.875rem);font-weight:var(--slider-tooltip-font-weight,600);line-height:var(--slider-tooltip-line-height,1.25rem);min-width:var(--slider-tooltip-min-width,20px);padding:var(--slider-tooltip-py,2px) var(--slider-tooltip-px,6px);position:absolute;text-align:center;white-space:nowrap}.slider-horizontal .slider-tooltip-top{bottom:calc(var(--slider-handle-height, 16px) + var(--slider-tooltip-arrow-size, 5px) + var(--slider-tooltip-distance, 3px));left:50%;transform:translate(-50%)}.slider-horizontal .slider-tooltip-top:before{border:var(--slider-tooltip-arrow-size,5px) solid transparent;border-top-color:inherit;bottom:calc(var(--slider-tooltip-arrow-size, 5px)*-2);content:"";height:0;left:50%;position:absolute;transform:translate(-50%);width:0}.slider-horizontal .slider-tooltip-bottom{left:50%;top:calc(var(--slider-handle-height, 16px) + var(--slider-tooltip-arrow-size, 5px) + var(--slider-tooltip-distance, 3px));transform:translate(-50%)}.slider-horizontal .slider-tooltip-bottom:before{border:var(--slider-tooltip-arrow-size,5px) solid transparent;border-bottom-color:inherit;content:"";height:0;left:50%;position:absolute;top:calc(var(--slider-tooltip-arrow-size, 5px)*-2);transform:translate(-50%);width:0}.slider-vertical .slider-tooltip-left{right:calc(var(--slider-handle-height, 16px) + var(--slider-tooltip-arrow-size, 5px) + var(--slider-tooltip-distance, 3px));top:50%;transform:translateY(-50%)}.slider-vertical .slider-tooltip-left:before{border:var(--slider-tooltip-arrow-size,5px) solid transparent;border-left-color:inherit;content:"";height:0;position:absolute;right:calc(var(--slider-tooltip-arrow-size, 5px)*-2);top:50%;transform:translateY(-50%);width:0}.slider-vertical .slider-tooltip-right{left:calc(var(--slider-handle-height, 16px) + var(--slider-tooltip-arrow-size, 5px) + var(--slider-tooltip-distance, 3px));top:50%;transform:translateY(-50%)}.slider-vertical .slider-tooltip-right:before{border:var(--slider-tooltip-arrow-size,5px) solid transparent;border-right-color:inherit;content:"";height:0;left:calc(var(--slider-tooltip-arrow-size, 5px)*-2);position:absolute;top:50%;transform:translateY(-50%);width:0}.slider-horizontal .slider-origin>.slider-tooltip{left:auto;transform:translate(50%)}.slider-horizontal .slider-origin>.slider-tooltip-top{bottom:calc(var(--slider-tooltip-arrow-size, 5px) + (var(--slider-handle-height, 16px) - var(--slider-height, 6px))/2 + var(--slider-tooltip-distance, 3px) + 1px)}.slider-horizontal .slider-origin>.slider-tooltip-bottom{top:calc(var(--slider-tooltip-arrow-size, 5px) + (var(--slider-handle-height, 16px) - var(--slider-height, 6px))/2 + var(--slider-tooltip-distance, 3px) + var(--slider-height, 6px) - 1px)}.slider-vertical .slider-origin>.slider-tooltip{top:auto;transform:translateY(calc((var(--slider-tooltip-line-height, 1.25rem) - var(--slider-tooltip-py, 2px))*-1 + 1px))}.slider-vertical .slider-origin>.slider-tooltip-left{right:calc(var(--slider-tooltip-arrow-size, 5px) + var(--slider-height, 6px) + (var(--slider-handle-height, 16px) - var(--slider-height, 6px))/2 + var(--slider-tooltip-distance, 3px) - 1px)}.slider-vertical .slider-origin>.slider-tooltip-right{left:calc(var(--slider-tooltip-arrow-size, 5px) + var(--slider-height, 6px) + (var(--slider-handle-height, 16px) - var(--slider-height, 6px))/2 + var(--slider-tooltip-distance, 3px) - var(--slider-height, 6px) + 1px)}div .kapix-slider-container{display:flex;flex-direction:row;align-items:center;width:100%}div .kapix-slider-container div .slider-connect{background:currentColor;height:var(--slider-dot-size)}div .kapix-slider-container .kapix-slider-unit-input{margin:auto;margin-top:0 10px;display:flex;height:var(--slider-thickness);width:100%}div .kapix-slider-container .kapix-slider-number-editor{max-width:70px;color:#000;margin-left:5px;border-radius:4px;text-align:center;box-shadow:0 3px 1px -2px #0003,0 2px 2px #00000024,0 1px 5px #0000001f}div .kapix-slider-container div .slider-connects{background-color:var(--slider-empty-color)}div .kapix-slider-container div .slider-handle{right:calc(var(--slider-dot-size, 16px) / 2 * -1);top:calc((var(--slider-dot-size, 16px) - var(--slider-thickness, 6px)) / 2 * -1);background-color:var(--slider-dot-color);height:var(--slider-dot-size);width:var(--slider-dot-size)}
`, Lr = ["placeholder", "value"], qr = /* @__PURE__ */ xr({
  __name: "KapixSliderInput",
  props: Cr([Number, Array]),
  emits: ["update:modelValue"],
  setup(V, { emit: A }) {
    Nr("KapixSliderInput", Ur);
    const f = V, st = A, O = gt({
      get() {
        return Vr(f);
      },
      set(S) {
        var M;
        st("update:modelValue", S), (M = f.onValueChanged) == null || M.call(f, S);
      }
    }), ft = gt(() => Pr(O.value)), tt = gt(() => {
      const S = f.options.fullColor || "currentColor", M = f.options.emptyColor || "rgb(201, 201, 201)", H = f.options.dotColor || "white", $ = Ee(f.options.dotSize), C = Ee(f.options.thickness), U = Math.max(0, Math.min(10, C ?? 0.5)), j = Math.max(0, Math.min(15, $ ?? 0.5)), d = `${U}em`, h = `${U + j}em`;
      return {
        color: S,
        "--slider-empty-color": M,
        "--slider-dot-color": H,
        "--slider-thickness": d,
        "--slider-dot-size": h
      };
    });
    return (S, M) => S.editable ? (qt(), Zt("div", {
      key: 0,
      class: Se(["kapix-slider-container", S.templateClass])
    }, [
      yr(At(te), {
        modelValue: At(O),
        "onUpdate:modelValue": M[0] || (M[0] = (H) => wr(O) ? O.value = H : null),
        class: "kapix-slider-unit-input",
        style: Sr(At(tt)),
        min: S.options.min != null ? S.options.min : 0,
        max: S.options.max != null ? S.options.max : 100,
        step: S.options.step,
        tooltips: !1
      }, null, 8, ["modelValue", "style", "min", "max", "step"]),
      S.options.showNumberInput !== !1 && !At(ft) ? (qt(), Zt("input", {
        key: 0,
        type: "number",
        class: Se(["kapix-slider-number-editor", S.templateClass]),
        placeholder: S.options.placeholder,
        value: At(O),
        onInput: M[1] || (M[1] = (H) => {
          var $;
          return O.value = ($ = H.target) == null ? void 0 : $.value;
        })
      }, null, 42, Lr)) : ke("", !0)
    ], 2)) : At(ft) ? ke("", !0) : (qt(), kr(zr, Er(Ne({ key: 1 }, f)), null, 16));
  }
});
export {
  qr as default
};
